/* Generated automatically by the program `genextract'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "diagnostic-core.h"

/* This variable is used as the "location" of any missing operand
   whose numbers are skipped by a given pattern.  */
static rtx junk ATTRIBUTE_UNUSED;

void
insn_extract (rtx_insn *insn)
{
  rtx *ro = recog_data.operand;
  rtx **ro_loc = recog_data.operand_loc;
  rtx pat = PATTERN (insn);
  int i ATTRIBUTE_UNUSED; /* only for peepholes */

  if (flag_checking)
    {
      memset (ro, 0xab, sizeof (*ro) * MAX_RECOG_OPERANDS);
      memset (ro_loc, 0xab, sizeof (*ro_loc) * MAX_RECOG_OPERANDS);
    }

  switch (INSN_CODE (insn))
    {
    default:
      /* Control reaches here if insn_extract has been called with an
         unrecognizable insn (code -1), or an insn whose INSN_CODE
         corresponds to a DEFINE_EXPAND in the machine description;
         either way, a bug.  */
      if (INSN_CODE (insn) < 0)
        fatal_insn ("unrecognizable insn:", insn);
      else
        fatal_insn ("insn with invalid code number:", insn);

    case 862:  /* ldstub */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 861:  /* swapsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 860:  /* *atomic_compare_and_swapdi_v8plus */
    case 859:  /* atomic_compare_and_swap_leon3_1 */
    case 858:  /* *atomic_compare_and_swapdi_1 */
    case 857:  /* *atomic_compare_and_swapsi_1 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1));
      recog_data.dup_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 852:  /* *membar_storeload */
    case 851:  /* *membar_storeload_leon3 */
    case 850:  /* *membar_storestore */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 854:  /* *membar */
    case 853:  /* *membar_v8 */
    case 849:  /* *membar_empty */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 836:  /* fpcmpugt8dishl */
    case 835:  /* fpcmpule8dishl */
    case 834:  /* fpcmpugt16dishl */
    case 833:  /* fpcmpule16dishl */
    case 832:  /* fpcmpugt32dishl */
    case 831:  /* fpcmpule32dishl */
    case 830:  /* fpcmpugt8sishl */
    case 829:  /* fpcmpule8sishl */
    case 828:  /* fpcmpugt16sishl */
    case 827:  /* fpcmpule16sishl */
    case 826:  /* fpcmpugt32sishl */
    case 825:  /* fpcmpule32sishl */
    case 824:  /* fpcmpne8dishl */
    case 823:  /* fpcmpeq8dishl */
    case 822:  /* fpcmpgt8dishl */
    case 821:  /* fpcmple8dishl */
    case 820:  /* fpcmpne16dishl */
    case 819:  /* fpcmpeq16dishl */
    case 818:  /* fpcmpgt16dishl */
    case 817:  /* fpcmple16dishl */
    case 816:  /* fpcmpne32dishl */
    case 815:  /* fpcmpeq32dishl */
    case 814:  /* fpcmpgt32dishl */
    case 813:  /* fpcmple32dishl */
    case 812:  /* fpcmpne8sishl */
    case 811:  /* fpcmpeq8sishl */
    case 810:  /* fpcmpgt8sishl */
    case 809:  /* fpcmple8sishl */
    case 808:  /* fpcmpne16sishl */
    case 807:  /* fpcmpeq16sishl */
    case 806:  /* fpcmpgt16sishl */
    case 805:  /* fpcmple16sishl */
    case 804:  /* fpcmpne32sishl */
    case 803:  /* fpcmpeq32sishl */
    case 802:  /* fpcmpgt32sishl */
    case 801:  /* fpcmple32sishl */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 791:  /* *nmuldf3_extend */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 732:  /* fmean16_vis */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 1), 0));
      break;

    case 720:  /* cmask32di_vis */
    case 719:  /* cmask32si_vis */
    case 718:  /* cmask16di_vis */
    case 717:  /* cmask16si_vis */
    case 716:  /* cmask8di_vis */
    case 715:  /* cmask8si_vis */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 786:  /* fpcmpueq32di_vis */
    case 785:  /* fpcmpugt32di_vis */
    case 784:  /* fpcmpune32di_vis */
    case 783:  /* fpcmpule32di_vis */
    case 782:  /* fpcmpueq16di_vis */
    case 781:  /* fpcmpugt16di_vis */
    case 780:  /* fpcmpune16di_vis */
    case 779:  /* fpcmpule16di_vis */
    case 778:  /* fpcmpueq32si_vis */
    case 777:  /* fpcmpugt32si_vis */
    case 776:  /* fpcmpune32si_vis */
    case 775:  /* fpcmpule32si_vis */
    case 774:  /* fpcmpueq16si_vis */
    case 773:  /* fpcmpugt16si_vis */
    case 772:  /* fpcmpune16si_vis */
    case 771:  /* fpcmpule16si_vis */
    case 770:  /* fucmpeq8di_vis */
    case 769:  /* fucmpgt8di_vis */
    case 768:  /* fucmpne8di_vis */
    case 767:  /* fucmple8di_vis */
    case 766:  /* fucmpeq8si_vis */
    case 765:  /* fucmpgt8si_vis */
    case 764:  /* fucmpne8si_vis */
    case 763:  /* fucmple8si_vis */
    case 690:  /* fpcmpeq8di_vis */
    case 689:  /* fpcmpgt8di_vis */
    case 688:  /* fpcmpne8di_vis */
    case 687:  /* fpcmple8di_vis */
    case 686:  /* fpcmpeq8si_vis */
    case 685:  /* fpcmpgt8si_vis */
    case 684:  /* fpcmpne8si_vis */
    case 683:  /* fpcmple8si_vis */
    case 682:  /* fcmpeq32di_vis */
    case 681:  /* fcmpgt32di_vis */
    case 680:  /* fcmpne32di_vis */
    case 679:  /* fcmple32di_vis */
    case 678:  /* fcmpeq32si_vis */
    case 677:  /* fcmpgt32si_vis */
    case 676:  /* fcmpne32si_vis */
    case 675:  /* fcmple32si_vis */
    case 674:  /* fcmpeq16di_vis */
    case 673:  /* fcmpgt16di_vis */
    case 672:  /* fcmpne16di_vis */
    case 671:  /* fcmple16di_vis */
    case 670:  /* fcmpeq16si_vis */
    case 669:  /* fcmpgt16si_vis */
    case 668:  /* fcmpne16si_vis */
    case 667:  /* fcmple16si_vis */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (pat, 1), 0, 0), 1));
      break;

    case 666:  /* edge32ldi_vis */
    case 665:  /* edge32lsi_vis */
    case 664:  /* edge32di_vis */
    case 663:  /* edge32si_vis */
    case 662:  /* edge16ldi_vis */
    case 661:  /* edge16lsi_vis */
    case 660:  /* edge16di_vis */
    case 659:  /* edge16si_vis */
    case 658:  /* edge8ldi_vis */
    case 657:  /* edge8lsi_vis */
    case 656:  /* edge8di_vis */
    case 655:  /* edge8si_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 652:  /* alignaddrlsi_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 697:  /* bmaskdi_vis */
    case 651:  /* alignaddrdi_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 698:  /* bmasksi_vis */
    case 653:  /* alignaddrldi_vis */
    case 650:  /* alignaddrsi_vis */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 645:  /* rdgsr_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 643:  /* wrgsr_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 526:  /* stack_protect_testdi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 525:  /* stack_protect_testsi */
      ro[0] = *(ro_loc[0] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 2), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 524:  /* stack_protect_setdi */
    case 523:  /* stack_protect_setsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 522:  /* *tldo_stx_sp64 */
    case 521:  /* *tldo_stwdi */
    case 520:  /* *tldo_stwsi */
    case 519:  /* *tldo_sthdi */
    case 518:  /* *tldo_sthsi */
    case 517:  /* *tldo_stbdi */
    case 516:  /* *tldo_stbsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 0), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 0), 0), 0), 0, 1));
      break;

    case 514:  /* *tldo_ldsw1_sp64 */
    case 513:  /* *tldo_lduw1_sp64 */
    case 510:  /* *tldo_ldsh2_sp64 */
    case 509:  /* *tldo_lduh2_sp64 */
    case 508:  /* *tldo_ldsh1di */
    case 507:  /* *tldo_ldsh1si */
    case 506:  /* *tldo_lduh1di */
    case 505:  /* *tldo_lduh1si */
    case 502:  /* *tldo_ldsb3_sp64 */
    case 501:  /* *tldo_ldub3_sp64 */
    case 500:  /* *tldo_ldsb2di */
    case 499:  /* *tldo_ldsb2si */
    case 498:  /* *tldo_ldsb1di */
    case 497:  /* *tldo_ldsb1si */
    case 496:  /* *tldo_ldub2di */
    case 495:  /* *tldo_ldub2si */
    case 494:  /* *tldo_ldub1di */
    case 493:  /* *tldo_ldub1si */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0, 1));
      break;

    case 515:  /* *tldo_ldx_sp64 */
    case 512:  /* *tldo_lduwdi */
    case 511:  /* *tldo_lduwsi */
    case 504:  /* *tldo_lduhdi */
    case 503:  /* *tldo_lduhsi */
    case 492:  /* *tldo_ldubdi */
    case 491:  /* *tldo_ldubsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 1));
      break;

    case 474:  /* tldm_calldi */
    case 473:  /* tldm_callsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 466:  /* tgd_calldi */
    case 465:  /* tgd_callsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 455:  /* prefetch_32 */
    case 454:  /* prefetch_64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      ro[2] = *(ro_loc[2] = &XEXP (pat, 2));
      break;

    case 451:  /* clzdi_v8plus */
    case 447:  /* popcountdi_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 644:  /* *rdgsr_sp64 */
    case 468:  /* tldm_hi22di */
    case 467:  /* tldm_hi22si */
    case 445:  /* stfsr */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      break;

    case 642:  /* *wrgsr_sp64 */
    case 440:  /* *branch_sp64 */
    case 439:  /* *branch_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 1));
      break;

    case 437:  /* update_return */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (pat, 0, 1));
      break;

    case 800:  /* dictunpack8 */
    case 799:  /* dictunpack16 */
    case 798:  /* dictunpack32 */
    case 795:  /* fhsubdf_vis */
    case 794:  /* fhsubsf_vis */
    case 793:  /* fhadddf_vis */
    case 792:  /* fhaddsf_vis */
    case 731:  /* pdistndi_vis */
    case 730:  /* pdistnsi_vis */
    case 721:  /* fchksm16_vis */
    case 714:  /* edge32lndi_vis */
    case 713:  /* edge32lnsi_vis */
    case 712:  /* edge32ndi_vis */
    case 711:  /* edge32nsi_vis */
    case 710:  /* edge16lndi_vis */
    case 709:  /* edge16lnsi_vis */
    case 708:  /* edge16ndi_vis */
    case 707:  /* edge16nsi_vis */
    case 706:  /* edge8lndi_vis */
    case 705:  /* edge8lnsi_vis */
    case 704:  /* edge8ndi_vis */
    case 703:  /* edge8nsi_vis */
    case 702:  /* bshufflev8qi_vis */
    case 701:  /* bshufflev4hi_vis */
    case 700:  /* bshufflev2si_vis */
    case 699:  /* bshufflev1di_vis */
    case 696:  /* array32di_vis */
    case 695:  /* array32si_vis */
    case 694:  /* array16di_vis */
    case 693:  /* array16si_vis */
    case 692:  /* array8di_vis */
    case 691:  /* array8si_vis */
    case 649:  /* faligndatav8qi_vis */
    case 648:  /* faligndatav4hi_vis */
    case 647:  /* faligndatav2si_vis */
    case 646:  /* faligndatav1di_vis */
    case 641:  /* fmuld8ulx16_vis */
    case 640:  /* fmuld8sux16_vis */
    case 639:  /* fmul8ulx16_vis */
    case 638:  /* fmul8sux16_vis */
    case 637:  /* fmul8x16al_vis */
    case 636:  /* fmul8x16au_vis */
    case 635:  /* fmul8x16_vis */
    case 632:  /* fpack32_vis */
    case 436:  /* probe_stack_rangedi */
    case 435:  /* probe_stack_rangesi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      break;

    case 456:  /* trap */
    case 441:  /* flush_register_windows */
    case 438:  /* nop */
    case 432:  /* blockage */
    case 431:  /* *return_internal */
    case 430:  /* eh_return_internal */
      break;

    case 444:  /* ldfsr */
    case 443:  /* flushdi */
    case 442:  /* flushsi */
    case 429:  /* window_save */
      ro[0] = *(ro_loc[0] = &XVECEXP (pat, 0, 0));
      break;

    case 420:  /* *call_symbolic_untyped_struct_value_sp32 */
    case 419:  /* *call_address_untyped_struct_value_sp32 */
    case 418:  /* *call_symbolic_struct_value_sp32 */
    case 417:  /* *call_address_struct_value_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[2] = *(ro_loc[2] = &XVECEXP (pat, 0, 1));
      break;

    case 426:  /* *sibcall_symbolic_sp64 */
    case 425:  /* *sibcall_symbolic_sp32 */
    case 416:  /* *call_symbolic_sp64 */
    case 415:  /* *call_address_sp64 */
    case 414:  /* *call_symbolic_sp32 */
    case 413:  /* *call_address_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      break;

    case 412:  /* *tablejump_sp64 */
    case 411:  /* *tablejump_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 1));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 0), 0));
      break;

    case 408:  /* *sparc.md:6782 */
    case 407:  /* *sparc.md:6766 */
    case 401:  /* *lshrsi3_extend1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 406:  /* *sparc.md:6754 */
    case 405:  /* *sparc.md:6742 */
    case 395:  /* *ashrsi3_extend1 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 367:  /* *nfmssf4 */
    case 363:  /* *nfmsdf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 2), 0));
      break;

    case 366:  /* *nfmasf4 */
    case 362:  /* *nfmadf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 365:  /* fmssf4 */
    case 361:  /* fmsdf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 364:  /* fmasf4 */
    case 360:  /* fmadf4 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 350:  /* *cmp_ccx_set64 */
    case 349:  /* *cmp_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (pat, 0, 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 342:  /* *cmp_ccv_neg_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 339:  /* *cmp_ccxv_neg */
    case 338:  /* *cmp_ccv_neg */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0);
      recog_data.dup_num[0] = 0;
      break;

    case 337:  /* *cmp_ccc_neg_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 341:  /* *cmp_ccxv_neg_set */
    case 340:  /* *cmp_ccv_neg_set */
    case 328:  /* negvdi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0);
      recog_data.dup_num[1] = 1;
      break;

    case 325:  /* *cmp_ccx_arith_op_not_set */
    case 324:  /* *cmp_cc_arith_op_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 323:  /* *cmp_ccx_arith_op_not */
    case 322:  /* *cmp_cc_arith_op_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 321:  /* *cmp_ccx_xor_not_set */
    case 320:  /* *cmp_cc_xor_not_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 319:  /* *cmp_ccx_xor_not */
    case 318:  /* *cmp_cc_xor_not */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 317:  /* *cmp_ccx_arith_op_set */
    case 316:  /* *cmp_cc_arith_op_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[0] = 2;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[1] = 1;
      break;

    case 315:  /* *cmp_ccx_arith_op */
    case 314:  /* *cmp_cc_arith_op */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 788:  /* *nadddf3 */
    case 787:  /* *naddsf3 */
    case 634:  /* fpmerge_vis */
    case 587:  /* *not_xorv8qi3 */
    case 586:  /* *not_andv8qi3 */
    case 585:  /* *not_iorv8qi3 */
    case 584:  /* *not_xorv4hi3 */
    case 583:  /* *not_andv4hi3 */
    case 582:  /* *not_iorv4hi3 */
    case 581:  /* *not_xorv2si3 */
    case 580:  /* *not_andv2si3 */
    case 579:  /* *not_iorv2si3 */
    case 578:  /* *not_xorv1di3 */
    case 577:  /* *not_andv1di3 */
    case 576:  /* *not_iorv1di3 */
    case 575:  /* *not_xorv4qi3 */
    case 574:  /* *not_andv4qi3 */
    case 573:  /* *not_iorv4qi3 */
    case 572:  /* *not_xorv2hi3 */
    case 571:  /* *not_andv2hi3 */
    case 570:  /* *not_iorv2hi3 */
    case 569:  /* *not_xorv1si3 */
    case 568:  /* *not_andv1si3 */
    case 567:  /* *not_iorv1si3 */
    case 400:  /* *lshrsi3_extend0 */
    case 394:  /* *ashrsi3_extend0 */
    case 313:  /* *xor_not_si */
    case 312:  /* *xor_not_di_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 301:  /* *umacdi */
    case 300:  /* *smacdi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 299:  /* *smacsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 294:  /* *cmp_sdiv_cc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 2), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 404:  /* lshrdi3_v8plus */
    case 398:  /* ashrdi3_v8plus */
    case 390:  /* ashldi3_v8plus */
    case 292:  /* divsi3_sp64 */
    case 291:  /* divsi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 290:  /* xmulxhi_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 289:  /* *xmulxhi_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0, 1), 0));
      break;

    case 288:  /* xmulx_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0, 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 287:  /* *xmulx_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1), 0));
      break;

    case 286:  /* umulxhi_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 284:  /* const_umulsi3_highpart */
    case 274:  /* const_smulsi3_highpart */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 285:  /* *umulxhi_sp64 */
    case 283:  /* *umulsi3_highpart_sp32 */
    case 273:  /* *smulsi3_highpart_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1), 0));
      break;

    case 282:  /* const_umulsi3_highpart_v8plus */
    case 272:  /* const_smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 281:  /* umulsi3_highpart_v8plus */
    case 271:  /* *sparc.md:4766 */
    case 270:  /* smulsi3_highpart_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 790:  /* *nmuldf3 */
    case 789:  /* *nmulsf3 */
    case 608:  /* *and_not1v8qi_vis */
    case 607:  /* *ior_not1v8qi_vis */
    case 606:  /* *and_not1v4hi_vis */
    case 605:  /* *ior_not1v4hi_vis */
    case 604:  /* *and_not1v2si_vis */
    case 603:  /* *ior_not1v2si_vis */
    case 602:  /* *and_not1v1di_vis */
    case 601:  /* *ior_not1v1di_vis */
    case 600:  /* *and_not1v4qi_vis */
    case 599:  /* *ior_not1v4qi_vis */
    case 598:  /* *and_not1v2hi_vis */
    case 597:  /* *ior_not1v2hi_vis */
    case 596:  /* *and_not1v1si_vis */
    case 595:  /* *ior_not1v1si_vis */
    case 402:  /* *lshrsi3_extend2 */
    case 396:  /* *ashrsi3_extend2 */
    case 309:  /* *or_not_si */
    case 308:  /* *or_not_di_sp64 */
    case 305:  /* *and_not_si */
    case 304:  /* *and_not_di_sp64 */
    case 279:  /* const_umulsidi3_sp64 */
    case 278:  /* const_umulsidi3_sp32 */
    case 269:  /* const_mulsidi3_sp64 */
    case 268:  /* const_mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 594:  /* *nandv8qi_vis */
    case 593:  /* *nandv4hi_vis */
    case 592:  /* *nandv2si_vis */
    case 591:  /* *nandv1di_vis */
    case 590:  /* *nandv4qi_vis */
    case 589:  /* *nandv2hi_vis */
    case 588:  /* *nandv1si_vis */
    case 369:  /* *multf3_extend */
    case 368:  /* *muldf3_extend */
    case 277:  /* *umulsidi3_sp64 */
    case 276:  /* *umulsidi3_sp32 */
    case 267:  /* *mulsidi3_sp64 */
    case 266:  /* *mulsidi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 280:  /* const_umulsidi3_v8plus */
    case 265:  /* const_mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 275:  /* umulsidi3_v8plus */
    case 264:  /* mulsidi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      break;

    case 262:  /* muldi3_v8plus */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[4] = *(ro_loc[4] = &XEXP (XVECEXP (pat, 0, 2), 0));
      break;

    case 253:  /* *cmp_ccc_minus_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 1), 0);
      recog_data.dup_num[3] = 2;
      break;

    case 244:  /* *subdi3_extend_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      break;

    case 252:  /* *cmpdi_set */
    case 251:  /* *cmpsi_set */
    case 241:  /* usubvdi4_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 258:  /* *cmp_ccv_minus_sltu_set */
    case 239:  /* *cmp_ccv_plus_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0), 1);
      recog_data.dup_num[3] = 2;
      break;

    case 255:  /* *cmp_ccxv_minus */
    case 254:  /* *cmp_ccv_minus */
    case 236:  /* *cmp_ccxv_plus */
    case 235:  /* *cmp_ccv_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0);
      recog_data.dup_num[1] = 0;
      break;

    case 234:  /* *cmp_ccc_plus_sltu_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 0), 0);
      recog_data.dup_num[2] = 1;
      recog_data.dup_loc[3] = &XEXP (XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0), 1), 0);
      recog_data.dup_num[3] = 2;
      break;

    case 231:  /* *cmp_ccxc_plus */
    case 230:  /* *cmp_ccc_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (pat, 1), 1);
      recog_data.dup_num[0] = 0;
      break;

    case 298:  /* *cmp_udiv_cc_set */
    case 263:  /* *cmp_mul_set */
    case 250:  /* *cmp_ccxnz_minus_set */
    case 249:  /* *cmp_ccnz_minus_set */
    case 229:  /* *cmp_ccxnz_plus_set */
    case 228:  /* *cmp_ccnz_plus_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      break;

    case 248:  /* *cmp_ccxnz_minus */
    case 247:  /* *cmp_ccnz_minus */
    case 227:  /* *cmp_ccxnz_plus */
    case 226:  /* *cmp_ccnz_plus */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      break;

    case 243:  /* *subx_extend_sp32 */
    case 222:  /* *addx_extend_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 1));
      break;

    case 257:  /* *cmp_ccxv_minus_set */
    case 256:  /* *cmp_ccv_minus_set */
    case 242:  /* subvdi4_sp32 */
    case 238:  /* *cmp_ccxv_plus_set */
    case 237:  /* *cmp_ccv_plus_set */
    case 221:  /* addvdi4_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 1);
      recog_data.dup_num[2] = 2;
      recog_data.dup_loc[3] = &XVECEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0, 0);
      recog_data.dup_num[3] = 1;
      break;

    case 233:  /* *cmp_ccxc_plus_set */
    case 232:  /* *cmp_ccc_plus_set */
    case 220:  /* uaddvdi4_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      recog_data.dup_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 1);
      recog_data.dup_num[1] = 2;
      recog_data.dup_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1);
      recog_data.dup_num[2] = 1;
      break;

    case 240:  /* subdi3_sp32 */
    case 219:  /* adddi3_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 200:  /* *cmp_zero_extract_sp64 */
    case 199:  /* *cmp_zero_extract */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 2));
      break;

    case 188:  /* *cmp_zero_extendqidi2_andcc_set */
    case 184:  /* *cmp_zero_extendqisi2_andcc_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 392:  /* *cmp_ccnz_set_ashift_1 */
    case 348:  /* *cmp_ccx_set_not */
    case 347:  /* *cmp_cc_set_not */
    case 336:  /* *cmp_ccxc_neg_set */
    case 335:  /* *cmp_ccc_neg_set */
    case 334:  /* *cmp_ccxnz_neg_set */
    case 333:  /* *cmp_ccnz_neg_set */
    case 327:  /* unegvdi3_sp32 */
    case 192:  /* *cmp_diqi_trunc_set */
    case 190:  /* *cmp_siqi_trunc_set */
    case 187:  /* *cmp_zero_extendqidi2_set */
    case 183:  /* *cmp_zero_extendqisi2_set */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      recog_data.dup_loc[0] = &XEXP (XEXP (XVECEXP (pat, 0, 1), 1), 0);
      recog_data.dup_num[0] = 1;
      break;

    case 410:  /* *jump_cbcond */
    case 409:  /* *jump_ubranch */
    case 186:  /* *cmp_zero_qi_sp64 */
    case 182:  /* *cmp_zero_qi */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 173:  /* *movtf_cc_reg_sp64 */
    case 172:  /* *movtf_cc_v9 */
    case 171:  /* *movtf_cc_reg_hq_sp64 */
    case 170:  /* *movtf_cc_hq_v9 */
    case 169:  /* movdf_cc_reg_sp64 */
    case 168:  /* movdf_cc_v9 */
    case 167:  /* *movsf_cc_reg_sp64 */
    case 166:  /* *movsf_cc_v9 */
    case 165:  /* *movdi_cc_reg_sp64 */
    case 164:  /* *movsi_cc_reg_sp64 */
    case 163:  /* *movhi_cc_reg_sp64 */
    case 162:  /* *movqi_cc_reg_sp64 */
    case 161:  /* *movdi_cc_v9 */
    case 160:  /* *movsi_cc_v9 */
    case 159:  /* *movhi_cc_v9 */
    case 158:  /* *movqi_cc_v9 */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (pat, 1), 1));
      ro[4] = *(ro_loc[4] = &XEXP (XEXP (pat, 1), 2));
      break;

    case 856:  /* atomic_storedi_1 */
    case 855:  /* atomic_loaddi_1 */
    case 633:  /* fexpand_vis */
    case 631:  /* fpackfix_vis */
    case 630:  /* fpack16_vis */
    case 434:  /* *frame_blockagedi */
    case 433:  /* *frame_blockagesi */
    case 143:  /* embmedany_brsum */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      break;

    case 480:  /* tldo_adddi */
    case 479:  /* tldo_addsi */
    case 464:  /* tgd_adddi */
    case 463:  /* tgd_addsi */
    case 127:  /* *movdi_lo_sum_pic_label_ref */
    case 123:  /* *movsi_lo_sum_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 1));
      break;

    case 797:  /* fnhadddf_vis */
    case 796:  /* fnhaddsf_vis */
    case 126:  /* *movdi_high_pic_label_ref */
    case 122:  /* *movsi_high_pic_label_ref */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 1));
      break;

    case 848:  /* fpcmpur8dishl */
    case 847:  /* fpcmpur16dishl */
    case 846:  /* fpcmpur32dishl */
    case 845:  /* fpcmpur8sishl */
    case 844:  /* fpcmpur16sishl */
    case 843:  /* fpcmpur32sishl */
    case 842:  /* fpcmpde8dishl */
    case 841:  /* fpcmpde16dishl */
    case 840:  /* fpcmpde32dishl */
    case 839:  /* fpcmpde8sishl */
    case 838:  /* fpcmpde16sishl */
    case 837:  /* fpcmpde32sishl */
    case 654:  /* pdist_vis */
    case 486:  /* tie_ld64 */
    case 485:  /* tie_ld32 */
    case 130:  /* movdi_pic_gotdata_op */
    case 121:  /* movsi_pic_gotdata_op */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (pat, 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (pat, 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (pat, 1), 0, 2));
      break;

    case 488:  /* tle_hix22di */
    case 487:  /* tle_hix22si */
    case 482:  /* tie_hi22di */
    case 481:  /* tie_hi22si */
    case 476:  /* tldo_hix22di */
    case 475:  /* tldo_hix22si */
    case 460:  /* tgd_hi22di */
    case 459:  /* tgd_hi22si */
    case 145:  /* embmedany_texthi */
    case 144:  /* embmedany_textuhi */
    case 141:  /* embmedany_sethi */
    case 138:  /* setlm */
    case 137:  /* sethh */
    case 134:  /* seth44 */
    case 129:  /* movdi_high_pic */
    case 120:  /* movsi_high_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XEXP (pat, 1), 0), 0, 0));
      break;

    case 490:  /* tle_lox10di */
    case 489:  /* tle_lox10si */
    case 484:  /* tie_lo10di */
    case 483:  /* tie_lo10si */
    case 478:  /* tldo_lox10di */
    case 477:  /* tldo_lox10si */
    case 472:  /* tldm_adddi */
    case 471:  /* tldm_addsi */
    case 462:  /* tgd_lo10di */
    case 461:  /* tgd_lo10si */
    case 146:  /* embmedany_textulo */
    case 139:  /* sethm */
    case 135:  /* setm44 */
    case 128:  /* movdi_lo_sum_pic */
    case 119:  /* movsi_lo_sum_pic */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XEXP (pat, 1), 1), 0, 0));
      break;

    case 537:  /* *movv8qi_insn_sp32 */
    case 536:  /* *movv4hi_insn_sp32 */
    case 535:  /* *movv2si_insn_sp32 */
    case 534:  /* *movv1di_insn_sp32 */
    case 533:  /* *movv8qi_insn_sp64 */
    case 532:  /* *movv4hi_insn_sp64 */
    case 531:  /* *movv2si_insn_sp64 */
    case 530:  /* *movv1di_insn_sp64 */
    case 529:  /* *movv4qi_insn */
    case 528:  /* *movv2hi_insn */
    case 527:  /* *movv1si_insn */
    case 458:  /* *trapdi_insn */
    case 457:  /* *trapsi_insn */
    case 157:  /* *movtf_insn_sp64_hq */
    case 156:  /* *movtf_insn_sp64 */
    case 155:  /* *movtf_insn_sp32 */
    case 154:  /* *movdf_insn_sp64 */
    case 153:  /* *movdf_insn_sp32 */
    case 150:  /* *movsf_insn */
    case 149:  /* *movti_insn_sp64_hq */
    case 148:  /* *movti_insn_sp64 */
    case 125:  /* *movdi_insn_sp64 */
    case 124:  /* *movdi_insn_sp32 */
    case 116:  /* *movsi_insn */
    case 114:  /* *movhi_insn */
    case 113:  /* *movqi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (pat, 1));
      break;

    case 112:  /* load_pcrel_symdi */
    case 111:  /* load_pcrel_symsi */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 0));
      ro[2] = *(ro_loc[2] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 1));
      ro[3] = *(ro_loc[3] = &XVECEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0, 2));
      break;

    case 110:  /* *inverted_int_branch_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 109:  /* *normal_int_branch_sp64 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 108:  /* *cbcond_sp64 */
    case 107:  /* *cbcond_sp32 */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 106:  /* *inverted_fpe_branch */
    case 104:  /* *inverted_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 105:  /* *normal_fpe_branch */
    case 103:  /* *normal_fp_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 102:  /* *inverted_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 2), 0));
      break;

    case 101:  /* *normal_branch */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 98:  /* *minus_minus_sltudi_subxc */
    case 97:  /* *minus_minus_sltusi_subxc */
    case 82:  /* *minus_minus_sltudi */
    case 81:  /* *minus_minus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 1), 0));
      break;

    case 94:  /* *neg_plus_sltudi_subxc */
    case 93:  /* *neg_plus_sltusi_subxc */
    case 78:  /* *neg_plus_sltudi */
    case 77:  /* *neg_plus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 92:  /* *minus_neg_sltudi_subxc */
    case 91:  /* *minus_neg_sltusi_subxc */
    case 76:  /* *minus_neg_sltudi */
    case 75:  /* *minus_neg_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 100:  /* *subxcdi */
    case 99:  /* *subxcsi */
    case 88:  /* *subxdi */
    case 87:  /* *subxsi */
    case 71:  /* *addxcdi */
    case 70:  /* *addxcsi */
    case 63:  /* *addxdi */
    case 62:  /* *addxsi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 622:  /* *and_not2v8qi_vis */
    case 621:  /* *ior_not2v8qi_vis */
    case 620:  /* *and_not2v4hi_vis */
    case 619:  /* *ior_not2v4hi_vis */
    case 618:  /* *and_not2v2si_vis */
    case 617:  /* *ior_not2v2si_vis */
    case 616:  /* *and_not2v1di_vis */
    case 615:  /* *ior_not2v1di_vis */
    case 614:  /* *and_not2v4qi_vis */
    case 613:  /* *ior_not2v4qi_vis */
    case 612:  /* *and_not2v2hi_vis */
    case 611:  /* *ior_not2v2hi_vis */
    case 610:  /* *and_not2v1si_vis */
    case 609:  /* *ior_not2v1si_vis */
    case 96:  /* *minus_sltudi_subxc */
    case 95:  /* *minus_sltusi_subxc */
    case 80:  /* *minus_sltudi */
    case 79:  /* *minus_sltusi */
    case 61:  /* *minus_sgeudi */
    case 60:  /* *minus_sgeusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 1), 0));
      break;

    case 74:  /* *neg_sltusidi */
    case 59:  /* *neg_sgeusidi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 69:  /* *plus_plus_sltudi_vis3 */
    case 68:  /* *plus_plus_sltusi_vis3 */
    case 56:  /* *plus_plus_sltudi */
    case 55:  /* *plus_plus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XEXP (XEXP (pat, 1), 0), 0), 0));
      break;

    case 86:  /* *plus_sgeudi */
    case 85:  /* *plus_sgeusi */
    case 67:  /* *plus_sltudi_vis3 */
    case 66:  /* *plus_sltusi_vis3 */
    case 54:  /* *plus_sltudi */
    case 53:  /* *plus_sltusi */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 46:  /* *minus_minus_snedidi_zero */
    case 45:  /* *minus_minus_snedisi_zero */
    case 42:  /* *minus_minus_snesidi_zero */
    case 41:  /* *minus_minus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 50:  /* *minus_seqsidi_zero */
    case 49:  /* *minus_seqsisi_zero */
    case 44:  /* *minus_snedidi_zero */
    case 43:  /* *minus_snedisi_zero */
    case 40:  /* *minus_snesidi_zero */
    case 39:  /* *minus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 38:  /* *plus_plus_snedidi_zero */
    case 37:  /* *plus_plus_snedisi_zero */
    case 34:  /* *plus_plus_snesidi_zero */
    case 33:  /* *plus_plus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 1));
      ro[3] = *(ro_loc[3] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 428:  /* *sibcall_value_symbolic_sp64 */
    case 427:  /* *sibcall_value_symbolic_sp32 */
    case 424:  /* *call_value_symbolic_sp64 */
    case 423:  /* *call_value_address_sp64 */
    case 422:  /* *call_value_symbolic_sp32 */
    case 421:  /* *call_value_address_sp32 */
    case 223:  /* *adddi3_extend_sp32 */
    case 48:  /* *plus_seqsidi_zero */
    case 47:  /* *plus_seqsisi_zero */
    case 36:  /* *plus_snedidi_zero */
    case 35:  /* *plus_snedisi_zero */
    case 32:  /* *plus_snesidi_zero */
    case 31:  /* *plus_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 1));
      break;

    case 452:  /* *clzsi_sp64 */
    case 448:  /* *popcountsi_sp64 */
    case 217:  /* fix_truncdfdi2 */
    case 216:  /* fix_truncsfdi2 */
    case 214:  /* fix_truncdfsi2 */
    case 213:  /* fix_truncsfsi2 */
    case 90:  /* *neg_sltudi_subxc */
    case 89:  /* *neg_sltusi_subxc */
    case 73:  /* *neg_sltudi */
    case 72:  /* *neg_sltusi */
    case 58:  /* *neg_sgeudi */
    case 57:  /* *neg_sgeusi */
    case 30:  /* *neg_seqdidi_zero */
    case 29:  /* *neg_seqdisi_zero */
    case 20:  /* *neg_snedidi_zero */
    case 19:  /* *neg_snedisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 629:  /* one_cmplv8qi2 */
    case 628:  /* one_cmplv4hi2 */
    case 627:  /* one_cmplv2si2 */
    case 626:  /* one_cmplv1di2 */
    case 625:  /* one_cmplv4qi2 */
    case 624:  /* one_cmplv2hi2 */
    case 623:  /* one_cmplv1si2 */
    case 470:  /* tldm_lo10di */
    case 469:  /* tldm_lo10si */
    case 453:  /* clzsi_v8plus */
    case 450:  /* *clzdi_sp64 */
    case 449:  /* popcountsi_v8plus */
    case 446:  /* *popcountdi_sp64 */
    case 387:  /* sqrtsf2 */
    case 386:  /* *sqrtdf2_fix */
    case 385:  /* *sqrtdf2_nofix */
    case 384:  /* *sqrttf2_hq */
    case 383:  /* abssf2 */
    case 382:  /* *absdf2_v9 */
    case 381:  /* *absdf2_notv9 */
    case 380:  /* *abstf2 */
    case 379:  /* *abstf2_hq */
    case 378:  /* negsf2 */
    case 377:  /* *negdf2_v9 */
    case 376:  /* *negdf2_notv9 */
    case 375:  /* *negtf2 */
    case 374:  /* *negtf2_hq */
    case 344:  /* one_cmplsi2 */
    case 343:  /* one_cmpldi2 */
    case 330:  /* negsi2 */
    case 329:  /* *negdi2_sp64 */
    case 218:  /* *fix_trunctfdi2_hq */
    case 215:  /* *fix_trunctfsi2_hq */
    case 212:  /* *floatditf2_hq */
    case 211:  /* floatdidf2 */
    case 210:  /* floatdisf2 */
    case 209:  /* *floatsitf2_hq */
    case 208:  /* floatsidf2 */
    case 207:  /* floatsisf2 */
    case 206:  /* *trunctfdf2_hq */
    case 205:  /* *trunctfsf2_hq */
    case 204:  /* truncdfsf2 */
    case 203:  /* *extenddftf2_hq */
    case 202:  /* *extendsftf2_hq */
    case 201:  /* extendsfdf2 */
    case 198:  /* *sign_extendsidi2_insn */
    case 197:  /* *sign_extendhidi2_insn */
    case 196:  /* *sign_extendqidi2_insn */
    case 195:  /* *sign_extendqisi2_insn */
    case 194:  /* *sign_extendqihi2_insn */
    case 193:  /* *sign_extendhisi2_insn */
    case 180:  /* *zero_extendsidi2_insn_sp32 */
    case 179:  /* *zero_extendsidi2_insn_sp64 */
    case 178:  /* *zero_extendhidi2_insn */
    case 177:  /* *zero_extendqidi2_insn */
    case 176:  /* *zero_extendqisi2_insn */
    case 175:  /* *zero_extendqihi2_insn */
    case 174:  /* *zero_extendhisi2_insn */
    case 152:  /* *movsf_high */
    case 132:  /* *sethi_di_medlow */
    case 131:  /* *sethi_di_medlow_embmedany_pic */
    case 118:  /* *movsi_high */
    case 84:  /* *sgeudi_insn */
    case 83:  /* *sgeusi_insn */
    case 65:  /* *sltudi_insn_vis3 */
    case 64:  /* *sltusi_insn_vis3 */
    case 52:  /* *sltudi_insn */
    case 51:  /* *sltusi_insn */
    case 28:  /* *seqdidi_zero */
    case 27:  /* *seqdisi_zero */
    case 16:  /* *snedidi_zero */
    case 15:  /* *snedisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      break;

    case 26:  /* *neg_seqsidi_zero */
    case 25:  /* *neg_seqsisi_zero */
    case 22:  /* *neg_snedidi_zero_subxc */
    case 21:  /* *neg_snedisi_zero_subxc */
    case 14:  /* *neg_snesidi_zero */
    case 13:  /* *neg_snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0), 0));
      break;

    case 326:  /* negdi2_sp32 */
    case 24:  /* *seqsidi_zero */
    case 23:  /* *seqsisi_zero */
    case 18:  /* *snedidi_zero_vis3 */
    case 17:  /* *snedisi_zero_vis3 */
    case 12:  /* *snesidi_zero */
    case 11:  /* *snesisi_zero */
      ro[0] = *(ro_loc[0] = &XEXP (XVECEXP (pat, 0, 0), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (XVECEXP (pat, 0, 0), 1), 0));
      break;

    case 762:  /* ussubv8qi3 */
    case 761:  /* usaddv8qi3 */
    case 760:  /* ussubv4hi3 */
    case 759:  /* usaddv4hi3 */
    case 758:  /* sssubv8qi3 */
    case 757:  /* ssaddv8qi3 */
    case 756:  /* maxuv2si3 */
    case 755:  /* minuv2si3 */
    case 754:  /* maxuv4hi3 */
    case 753:  /* minuv4hi3 */
    case 752:  /* maxuv8qi3 */
    case 751:  /* minuv8qi3 */
    case 750:  /* maxv2si3 */
    case 749:  /* minv2si3 */
    case 748:  /* maxv4hi3 */
    case 747:  /* minv4hi3 */
    case 746:  /* maxv8qi3 */
    case 745:  /* minv8qi3 */
    case 744:  /* sssubv1si3 */
    case 743:  /* ssaddv1si3 */
    case 742:  /* sssubv2hi3 */
    case 741:  /* ssaddv2hi3 */
    case 740:  /* sssubv2si3 */
    case 739:  /* ssaddv2si3 */
    case 738:  /* sssubv4hi3 */
    case 737:  /* ssaddv4hi3 */
    case 736:  /* subv8qi3 */
    case 735:  /* addv8qi3 */
    case 734:  /* fpsub64_vis */
    case 733:  /* fpadd64_vis */
    case 729:  /* vashrv2si3 */
    case 728:  /* vlshrv2si3 */
    case 727:  /* vssashlv2si3 */
    case 726:  /* vashlv2si3 */
    case 725:  /* vashrv4hi3 */
    case 724:  /* vlshrv4hi3 */
    case 723:  /* vssashlv4hi3 */
    case 722:  /* vashlv4hi3 */
    case 566:  /* xorv8qi3 */
    case 565:  /* andv8qi3 */
    case 564:  /* iorv8qi3 */
    case 563:  /* xorv4hi3 */
    case 562:  /* andv4hi3 */
    case 561:  /* iorv4hi3 */
    case 560:  /* xorv2si3 */
    case 559:  /* andv2si3 */
    case 558:  /* iorv2si3 */
    case 557:  /* xorv1di3 */
    case 556:  /* andv1di3 */
    case 555:  /* iorv1di3 */
    case 554:  /* xorv4qi3 */
    case 553:  /* andv4qi3 */
    case 552:  /* iorv4qi3 */
    case 551:  /* xorv2hi3 */
    case 550:  /* andv2hi3 */
    case 549:  /* iorv2hi3 */
    case 548:  /* xorv1si3 */
    case 547:  /* andv1si3 */
    case 546:  /* iorv1si3 */
    case 545:  /* subv4hi3 */
    case 544:  /* addv4hi3 */
    case 543:  /* subv2hi3 */
    case 542:  /* addv2hi3 */
    case 541:  /* subv2si3 */
    case 540:  /* addv2si3 */
    case 539:  /* subv1si3 */
    case 538:  /* addv1si3 */
    case 403:  /* *lshrdi3_sp64 */
    case 399:  /* lshrsi3 */
    case 397:  /* *ashrdi3_sp64 */
    case 393:  /* ashrsi3 */
    case 389:  /* *ashldi3_sp64 */
    case 388:  /* ashlsi3 */
    case 373:  /* divsf3 */
    case 372:  /* *divdf3_fix */
    case 371:  /* *divdf3_nofix */
    case 370:  /* *divtf3_hq */
    case 359:  /* mulsf3 */
    case 358:  /* muldf3 */
    case 357:  /* *multf3_hq */
    case 356:  /* subsf3 */
    case 355:  /* subdf3 */
    case 354:  /* *subtf3_hq */
    case 353:  /* addsf3 */
    case 352:  /* adddf3 */
    case 351:  /* *addtf3_hq */
    case 311:  /* xorsi3 */
    case 310:  /* xordi3 */
    case 307:  /* iorsi3 */
    case 306:  /* iordi3 */
    case 303:  /* andsi3 */
    case 302:  /* anddi3 */
    case 297:  /* udivdi3 */
    case 296:  /* udivsi3_sp64 */
    case 295:  /* udivsi3_sp32 */
    case 293:  /* divdi3 */
    case 261:  /* *muldi3_sp64 */
    case 260:  /* *mulsi3_sp64 */
    case 259:  /* *mulsi3_sp32 */
    case 246:  /* subsi3 */
    case 245:  /* *subdi3_sp64 */
    case 225:  /* addsi3 */
    case 224:  /* *adddi3_sp64 */
    case 151:  /* *movsf_lo_sum */
    case 147:  /* embmedany_textlo */
    case 142:  /* embmedany_losum */
    case 140:  /* setlo */
    case 136:  /* setl44 */
    case 133:  /* *losum_di_medlow */
    case 117:  /* *movsi_lo_sum */
    case 115:  /* *movhi_lo_sum */
    case 10:  /* *cmptf_fp */
    case 9:  /* *cmpdf_fp */
    case 8:  /* *cmpsf_fp */
    case 7:  /* *cmptf_fpe */
    case 6:  /* *cmpdf_fpe */
    case 5:  /* *cmpsf_fpe */
      ro[0] = *(ro_loc[0] = &XEXP (pat, 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 0));
      ro[2] = *(ro_loc[2] = &XEXP (XEXP (pat, 1), 1));
      break;

    case 391:  /* *cmp_ccnz_ashift_1 */
    case 346:  /* *cmp_ccx_not */
    case 345:  /* *cmp_cc_not */
    case 332:  /* *cmp_ccxnz_neg */
    case 331:  /* *cmp_ccnz_neg */
    case 191:  /* *cmp_diqi_trunc */
    case 189:  /* *cmp_siqi_trunc */
    case 185:  /* *cmp_zero_extendqidi2 */
    case 181:  /* *cmp_zero_extendqisi2 */
    case 4:  /* *cmpdi_sne */
    case 3:  /* *cmpsi_sne */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (XEXP (pat, 1), 0), 0));
      break;

    case 2:  /* *cmpdi_sp64 */
    case 1:  /* *cmpsi_insn */
      ro[0] = *(ro_loc[0] = &XEXP (XEXP (pat, 1), 0));
      ro[1] = *(ro_loc[1] = &XEXP (XEXP (pat, 1), 1));
      break;

    }
}
